//+------------------------------------------------------------------+
//|                                             Alen_TwoMA_Alert.mq4 |
//|                                          Copyright  2011,Alen_T |
//|                                             http://fxgeneral.com |
//+------------------------------------------------------------------+
//     ()    MA_High (Low)

#property copyright "Copyright  2011,Alen_T"
#property link      "http://fxgeneral.com"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 6
#property  indicator_color1  Blue
#property  indicator_color2  Red
#property  indicator_color3  Green
#property  indicator_color4  Orange

//---- indicator parameters
extern int  SIGNAL_BAR = 1;    //  
extern int  dLevel     = 5;    //    (+, -)
extern string CommentS =    "----- ALERTs -----";
extern bool ShowAlert     = true; // 
extern bool allAlert  = true; // .   ( ).
                               //(  SIGNAL_BAR = 0)

extern string CommentS1 =    "----- SYMBOLs -----";
extern bool showSimbol = true; // 
extern int  widthSimbol = 2;   // 
extern bool allSymbol   = false; //  (   )
                                // allSignal
extern int  indexSymbolUp = 233; //241 //  buy
extern int  indexSymbolDn = 234; //242 //  sell                           

extern string CommentS2 =    "----- MA Indicator Settings -----";
extern int    ma_period = 5;   //     . 
extern int    ma_shift  = 1;   //    , (+,-)
extern int    ma_method = 3;   // .
    //MODE_SMA 0    
    //MODE_EMA 1    
    //MODE_SMMA 2    
    //MODE_LWMA 3 -   

//---- indicator buffers
double i_MAH[];
double i_MAL[];
double i_MAHlevel[];
double i_MALlevel[];
double i_MAHl_s[];
double i_MALl_s[];
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping
    SetIndexBuffer(0,i_MAH);
    SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
    SetIndexBuffer(1,i_MAL);
    SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
    SetIndexBuffer(2,i_MAHlevel);
    SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
    SetIndexBuffer(3,i_MALlevel);
    SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
    SetIndexBuffer(4,i_MALl_s);
    SetIndexStyle(4,DRAW_ARROW, EMPTY, widthSimbol, Blue);
    SetIndexArrow(4,indexSymbolUp);
    SetIndexBuffer(5,i_MAHl_s);
    SetIndexStyle(5,DRAW_ARROW, EMPTY, widthSimbol, Red);
    SetIndexArrow(5,indexSymbolDn);
    IndicatorShortName("Alen_TwoMA ("+ ma_period +")");
    return(0);
}
//+------------------------------------------------------------------+
int start()
{
int CountedBars;  

    if(Bars <= ma_period) return(0);
    CountedBars = IndicatorCounted();
int   i = Bars - ma_period - 1;
    if(CountedBars > ma_period) i = Bars - ma_period - 1;  
int PrevSymbol = 0;
    while(i >= 0) {
        i_MAH[i] = MA(0, PRICE_HIGH, i);
        i_MAHlevel[i] = i_MAH[i]+ dLevel * Point;
        i_MAL[i] = MA(0, PRICE_LOW, i);
        i_MALlevel[i] = i_MAL[i]- dLevel * Point;
        if(showSimbol) {
            if(PrevSymbol <= 0 || allSymbol) {
                if(Open[i+SIGNAL_BAR] < Close[i+SIGNAL_BAR] &&           // 
                    Low[i+SIGNAL_BAR] < i_MAHlevel[i+SIGNAL_BAR] &&      //Low < . MA
                    Close[i+SIGNAL_BAR] >= i_MAHlevel[i+SIGNAL_BAR]) {//Close >= . MA
                        i_MALl_s[i+SIGNAL_BAR] = Low[i+SIGNAL_BAR] - 5 * Point;
                        PrevSymbol = 1;
                }
            }
            if(PrevSymbol >= 0 || allSymbol) {
                if(Open[i+SIGNAL_BAR] > Close[i+SIGNAL_BAR] &&           // 
                    High[i+SIGNAL_BAR] > i_MALlevel[i+SIGNAL_BAR] &&     //High > . MA
                    Close[i+SIGNAL_BAR] <= i_MALlevel[i+SIGNAL_BAR]) {//Close <= . MA
                        i_MAHl_s[i+SIGNAL_BAR] = High[i+SIGNAL_BAR] + 5 * Point;
                        PrevSymbol = -1;
                }
            }
        }
        i--;
    }
//===== Alert ======
	  static int PrevSignal = 0, PrevTime = 0;
	  if(SIGNAL_BAR > 0 && Time[0] <= PrevTime) return(0);
	  PrevTime = Time[0];
	  if(ShowAlert) {
	   if(PrevSignal <= 0 || allAlert) {
		     if(Open[SIGNAL_BAR] < Close[SIGNAL_BAR] &&          // 
		          Low[SIGNAL_BAR] < i_MAHlevel[SIGNAL_BAR] &&   //Low < . MA
		           Close[SIGNAL_BAR] >= i_MAHlevel[SIGNAL_BAR]) //Close >= . MA
		       {
			        PrevSignal = 1;
			        Alert("TwoMA (", Symbol(), ", ",Period(), ") - BUY! Low = "+ DoubleToStr(Low[SIGNAL_BAR], Digits));
		       }
	    }
	   if(PrevSignal >= 0 || allAlert) {
		     if(Open[SIGNAL_BAR] > Close[SIGNAL_BAR] &&           // 
		          High[SIGNAL_BAR] > i_MALlevel[SIGNAL_BAR] &&   //High > . MA
		           Close[SIGNAL_BAR] <= i_MALlevel[SIGNAL_BAR])  //Close <= . MA
		       {
			        PrevSignal = -1;
			        Alert("TwoMA (", Symbol(), ", ",Period(), ")  -  SELL! High = "+ DoubleToStr(High[SIGNAL_BAR], Digits));
		       }
	    }
      }
   return(0);
}
//--------------------------------------------------------------------  
double MA(int _tf, int _price, int _bar) {return(iMA(NULL, _tf, ma_period,ma_shift,ma_method,_price, _bar));}